using System;
using System.Threading;

class Counter
{
	private object o;
	private long counter = 0;

	public Counter(object o)
	{
		this.o = o;
	}

	public void IncrementCounter()
	{
		Monitor.Enter(o);
		Console.WriteLine("Thread {0} entered IncrementCounter", Thread.CurrentThread.GetHashCode());
		long oldValue = counter;
		oldValue += 1;
		Thread.Sleep(0);
		counter = oldValue;
		Console.WriteLine("Thread {0} exited IncrementCounter", Thread.CurrentThread.GetHashCode());
		Monitor.Exit(o);	
	}

	public long GetCounter()
	{
		return counter;
	}

}

class Action
{
	private Counter counter;

	public Action (int start, int increment, int end, Counter counter)
	{
		this.start = start;
		this.increment = increment;
		this.end = end;
		this.counter = counter;
	}

	private int start;
	private int increment;
	private int end;

	public void Count()
	{
		for (int i = start; i <= end; i += increment)
		{
			Console.WriteLine("Thread {0} has value {1}", Thread.CurrentThread.GetHashCode(), i);
			Thread.Sleep(500);
			counter.IncrementCounter();	
		}
	}

}

class Example
{
	static void Main()
	{
		Object o = new Object();
		Counter counter = new Counter(o);

		Action a1 = new Action(1, 10, 100, counter);
		Action a2 = new Action(100, 10, 200, counter);

		ThreadStart ts1 = new ThreadStart(a1.Count);
		ThreadStart ts2 = new ThreadStart(a2.Count);

		Thread t1 = new Thread(ts1);
		Thread t2 = new Thread(ts2);

		t1.Start();
		t2.Start();

		t1.Join();
		t2.Join();

		Console.WriteLine("Number of counts: {0}", counter.GetCounter());

	}
}



