using System;
using System.Collections;
using System.Reflection;

class Host
{
	static void Main()
	{
		AppDomain appDomain1 = AppDomain.CreateDomain("NewAppDomain1");
		appDomain1.AssemblyLoad += new AssemblyLoadEventHandler(AssemblyLoadHandler);
		appDomain1.DomainUnload += new EventHandler(AppDomainUnloadHandler);

		appDomain1.ExecuteAssembly("TargetAssembly.exe");

		AppDomain appDomain2 = AppDomain.CreateDomain("NewAppDomain2");
		appDomain2.AssemblyLoad += new AssemblyLoadEventHandler(AssemblyLoadHandler);
		appDomain2.DomainUnload += new EventHandler(AppDomainUnloadHandler);
		appDomain2.ExecuteAssembly("TargetAssembly.exe");

		AppDomain.Unload(appDomain1);
		AppDomain.Unload(appDomain2);

		AppDomain defaultDomain = AppDomain.CurrentDomain;
		try
		{
			AppDomain.Unload(defaultDomain);
		}
		catch(Exception e)
		{
			Console.WriteLine("Exception:" + e.Message);
		}		
	}

	static public void AssemblyLoadHandler (object sender, AssemblyLoadEventArgs args)
	{
		Console.WriteLine(args.LoadedAssembly + " Loaded.");

	}

	static public void AppDomainUnloadHandler (object sender, EventArgs args)
	{
		Console.WriteLine("AppDomain being unloaded. Perform any cleanup actions.");
	}
}


